/*
 * Kerze_WS2812.c
 *
 * Created: 13.10.2013 21:38
 *  Author: Tim

 Hardware:
	- Attiny 10
	- 1x WS2812 LED on PB2
	- Touchpad on PB1 (not used)
 */ 

#define F_CPU 8000000

#include <avr/io.h>
#include <util/delay.h>
#include "light_ws2812.h"
//#include "TinyTouchLib.h"
	
struct CRGB { int8_t g; int8_t r; int8_t b; };
struct CRGB led[1];



//	Kerze/Lagerfeuer

struct CRGB col1={90,127,10};   // colour values are signed! 127=maximum brightness, 254 in led.
struct CRGB col2={30,100,00};   

#define freq		16			// update RND input every nth cycle
#define iir_coef	7			// iir_coef=2^n-1 where n is a positive integer
								// higher values will smooth more, 0= no smoothing
#define nonlinear				// Random values are biased toward col1			


/*
//	Schweissgert
	
struct CRGB col1={25,25,127};   
struct CRGB col2={100,100,127};  

#define freq		2			// update RND input every nth cycle
#define iir_coef	3			// iir_coef=2^n-1 where n is a positive integer
								// higher values will smooth more, 0= no smoothing
#define nonlinear				// Random values are biased toward col1			

*/

/*
// alien
struct CRGB col1={0,127,127};   
struct CRGB col2={127,00,0};   

#define freq		255			// update RND input every nth cycle
#define iir_coef	63			// iir_coef=2^n-1 where n is a positive integer
*/


// *************************************************************************************
// *   FUNKTION - 32-Bit Zufallszahlen     
// Author:   Jens Grtler
// Erstellt: 10.01.2010                                            *
// *************************************************************************************
unsigned char My_Rand() {
	static unsigned long Z;
	if (Z == 0) Z = 0x47110815;

	if (Z & 0x80000000) {
		Z<<=1;
		Z^=0x04C11DB7;
	}
	else {
		Z<<=1;
	}
	return Z;
}

int main(void)
{
	uint8_t ledon=0;
	uint8_t intens=0;
	uint8_t ctr=0;
	uint8_t input=0;

	CCP=0xD8;		// configuration change protection, write signature
	CLKPSR=0;		// set cpu clock prescaler =1 (8Mhz) (attiny 4/5/9/10)

	DDRB|=_BV(PB2);  // Output pin for WS2812
															
    while(1)
    {
			
		if (ctr==freq) {
			 input=My_Rand();				// Update random input value every "freq" calls
#ifdef nonlinear				
			 input=(input*input)>>8;		// Square to nonlinearly bias values towards 0 ("candle is 
#endif			 
		
			 ctr=0;
		} else {
			ctr++;
		}
		
		intens=(intens*iir_coef+input)/(iir_coef+1);	// IIR-Low pass to create smooth transitions between the random input values
	
	// LED color is interpolated between col1 and col2

		led[0].r=(col1.r<<1)+(((col2.r-col1.r)*intens)>>7);
		led[0].g=(col1.g<<1)+(((col2.g-col1.g)*intens)>>7);
		led[0].b=(col1.b<<1)+(((col2.b-col1.b)*intens)>>7);
		
		ws2812_sendarray_mask(led,3,_BV(PB2));
		_delay_ms(5);
    }
}

